# Generated by Django 3.0.11 on 2021-02-05 08:49

from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = []

    operations = [
        migrations.CreateModel(
            name="Cell",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "name",
                    models.CharField(
                        help_text="Full name of the cell.", max_length=30, unique=True
                    ),
                ),
                (
                    "abbreviation",
                    models.CharField(
                        blank=True,
                        help_text="Abbreviation of the cell name.",
                        max_length=6,
                        unique=True,
                    ),
                ),
                (
                    "workspace_id",
                    models.PositiveIntegerField(
                        help_text="The ID of the workspace.", unique=True
                    ),
                ),
            ],
            options={
                "ordering": ["name"],
            },
        ),
        migrations.CreateModel(
            name="Role",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "name",
                    models.CharField(
                        help_text="Full name of the role.", max_length=30, unique=True
                    ),
                ),
                (
                    "abbreviation",
                    models.CharField(
                        blank=True,
                        help_text="abbreviation of the role name. If not set, one will be generated.",
                        max_length=6,
                        unique=True,
                    ),
                ),
                (
                    "permanent",
                    models.BooleanField(
                        default=False,
                        help_text="Indicate if a role must be added to all cell members.",
                    ),
                ),
                (
                    "subscribe_to_boards",
                    models.BooleanField(
                        default=False,
                        help_text="Controls if the user with the given role should be subscribed to all\n        sprint checklists within the given sprint for the belonging cell.",
                    ),
                ),
            ],
            options={
                "ordering": ["name"],
            },
        ),
        migrations.CreateModel(
            name="SprintChecklist",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "board_id",
                    models.PositiveIntegerField(
                        help_text="The ID of the board.", unique=True
                    ),
                ),
                (
                    "board_name",
                    models.CharField(
                        help_text="Human readable name of the board.",
                        max_length=255,
                        unique=True,
                    ),
                ),
                (
                    "state",
                    models.CharField(
                        choices=[
                            ("all", "all"),
                            ("active", "active"),
                            ("archived", "archived"),
                            ("deleted", "deleted"),
                        ],
                        help_text="The current state of a board.",
                        max_length=8,
                    ),
                ),
                (
                    "sprint_id",
                    models.PositiveIntegerField(help_text="The ID of the sprint."),
                ),
                (
                    "member",
                    models.EmailField(
                        help_text="Email address of the OpenCraft member.",
                        max_length=254,
                    ),
                ),
                (
                    "cell",
                    models.ForeignKey(
                        help_text="Name of the OpenCraft cell where the board belongs to.",
                        on_delete=django.db.models.deletion.CASCADE,
                        to="sprint_checklist.Cell",
                    ),
                ),
                ("roles", models.ManyToManyField(to="sprint_checklist.Role")),
            ],
            options={
                "ordering": ["-sprint_id"],
                "unique_together": {("sprint_id", "cell", "member")},
            },
        ),
    ]
